/* Windows Sytem cursor change Ver.1.10  */
/* Copyright (C) 1993 by Y.Shirakwa.     */
/* lastupdate 93'05/01                   */
/* #define STRICT                        */

/* Contains the necessary headers and definitions for this program */
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <shellapi.h>
#include "cgcur.h"

/***  Global Variables  ***/
LPSTR szName[L_SIZE];
WORD  size;
unsigned char buf[L_SIZE], tmp[L_SIZE]; /* read buffer, cursor buffer */
LPSTR   lpArrow;        /* 32bit far pointer */
HCURSOR hCurArrow;
char appName[] = "ChangeCursorV1.10";
BOOL Top;         /* Window Z-Oder topmost*/

/* Prototype Declarations*/
LRESULT FAR PASCAL _export WndProc (HWND, UINT, WPARAM, LPARAM);
int CMUFileOpen(HWND);


/* Windows entry function */
int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
     WNDCLASS wndClass;
     MSG  msg;
     HWND hWnd;

     if ( !hPrevInstance )
     {
          wndClass.style	     = CS_HREDRAW | CS_VREDRAW;
          wndClass.lpfnWndProc   = WndProc;
          wndClass.cbClsExtra	 = NULL;
          wndClass.cbWndExtra	 = NULL;                
          wndClass.hInstance 	 = hInstance;
          wndClass.hIcon	     = LoadIcon(hInstance, "ICON_1");
          wndClass.hCursor	     = LoadCursor(NULL, IDC_ARROW );
          wndClass.hbrBackground = (HBRUSH)GetStockObject( WHITE_BRUSH );
          wndClass.lpszMenuName  = NULL;
          wndClass.lpszClassName = appName;

          if ( !RegisterClass( &wndClass ) )
               return FALSE;
     }
     else {
          hWnd = CreateWindow(appName, appName, WS_OVERLAPPEDWINDOW, 0, 0, 0, 0, 0, 0, hInstance, NULL);
          MessageBox(hWnd, "Already rxists!", appName, MB_ICONEXCLAMATION);
          return FALSE;
     }

     /*_InitEasyWin();
     printf("%d\n", HIBYTE(LOWORD(GetVersion()))); */

     /* hWnd = CreateWindow(appName, appName, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, 0, 0, hInstance, NULL); */
     /* hWnd = CreateWindow(appName, appName, WS_OVERLAPPEDWINDOW, 0, 0, 0, 0, 0, 0, hInstance, NULL); */
     if (HIBYTE(LOWORD(GetVersion())) == 10) {    /* ver 3.1 ? */
          /* accepts drag-drop files style */
          hWnd = CreateWindowEx(WS_EX_ACCEPTFILES, appName, appName, WS_OVERLAPPED | WS_VISIBLE | WS_CAPTION | WS_SYSMENU, 0, 0, 0, 0, 0, 0, hInstance, NULL);
     }
     else {
          hWnd = CreateWindow(appName, appName, WS_OVERLAPPED | WS_VISIBLE | WS_CAPTION | WS_SYSMENU, 0, 0, 0, 0, 0, 0, hInstance, NULL);
     }

     /* ShowWindow( hWnd, nCmdShow ); */
     ShowWindow( hWnd, SW_SHOWMINNOACTIVE);

     while ( GetMessage( &msg, 0, 0, 0 ) )
     {
          TranslateMessage( &msg );
          DispatchMessage( &msg );
     }

     return msg.wParam;
}


/* change cursor procedure */
void cgcur(HWND hWnd, LPCSTR lpszName)
{
     WORD  loop;
     HFILE hfReadFile;       /* 16-bit value used as a file handle */

     if (_fstricmp(".CUR" , &lpszName[_fstrlen(lpszName) - 4]) != 0) {
          MessageBox(hWnd, "Not cursor file!", appName, MB_ICONINFORMATION);
          return;
     }
     /* Open the input file (read only). */
     if ((hfReadFile = _lopen(lpszName, READ)) == HFILE_ERROR) {
          MessageBox(hWnd, "Can not open", appName, MB_ICONINFORMATION);
     }
     else {
          _lread(hfReadFile, buf, 326);
          _lclose(hfReadFile);
          lpArrow = GlobalLock(hCurArrow);
          ((LPCURSORHEADER)lpArrow)->wHotSpotX = buf[10];
          ((LPCURSORHEADER)lpArrow)->wHotSpotY = buf[12];
          for (loop = 0; loop < 128; ++loop) {
               *((unsigned char far*)lpArrow + loop + 12) = buf[124-8*(loop/4)+loop+198];
          }
          for (loop = 0; loop < 128; ++loop) {
               *((unsigned char far*)lpArrow + loop + 128 + 12) = buf[124-8*(loop/4)+loop+70];
          }
          GlobalUnlock(hCurArrow);
          ShowCursor(FALSE);
          ShowCursor(TRUE);
     }
}


/* Windows porcedure */
LRESULT FAR PASCAL _export WndProc (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
     HMENU hmenu;
     WORD  loop;
     WORD  wFilesDropped, wSize;
     NPSTR npszPathName;

     switch(Message) {
     case WM_CREATE:
          /* Set Systemmenu */
          hmenu = GetSystemMenu(hWnd, FALSE);
          AppendMenu(hmenu, MF_SEPARATOR, 0, (LPSTR) NULL);
          AppendMenu(hmenu, MF_STRING, IDM_FILE, "&File");
          if (HIBYTE(LOWORD(GetVersion())) == 10) {    /* ver 3.1 ? */
			   if ((Top = SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE))) {
                    AppendMenu(hmenu, MF_CHECKED, IDM_TOP, "&TopWindow");
               }
          }
          AppendMenu(hmenu, MF_STRING, IDM_ABOUT, "&About...");
          /* System cursor IDC_ARROW get */
          hCurArrow = LoadCursor(NULL, IDC_ARROW);
          lpArrow = GlobalLock(hCurArrow);
          /* Allocate Tmp memory and memry block lock */
          size = sizeof(CURSORHEADER) + 2 * ((((LPCURSORHEADER)lpArrow)->wExtentX / 8)
          * ((LPCURSORHEADER)lpArrow)->wExtentY);
          /* copy system cursor arrow to tmp */
          for (loop = 0; loop < size; loop++)
               tmp[loop] = *((unsigned char far*)lpArrow + loop);
          GlobalUnlock(hCurArrow);
          /* debug window create */
          /*_InitEasyWin(); */
          break;
     case WM_SYSCOMMAND:
          /* Systemmenu message procecure */
          switch (wParam) {
          case IDM_FILE:
               if (CMUFileOpen(hWnd)) {
                    cgcur(hWnd, (LPCSTR)szName);
               }
               break;
          case IDM_TOP:
		  if (HIBYTE(LOWORD(GetVersion())) == 10) {    /* ver 3.1 ? */
			   hmenu = GetSystemMenu(hWnd, FALSE);
               /* setup window Z-oder*/
               if (Top) {
                    SetWindowPos(hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
                    CheckMenuItem(hmenu, IDM_TOP, MF_UNCHECKED);
                    Top = FALSE;
               }
               else {
                    SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
                    CheckMenuItem(hmenu, IDM_TOP, MF_CHECKED);
                    Top = TRUE;
			   }
               }
               break;
          case IDM_ABOUT:
               MessageBox(hWnd, "(C) 1993 by Y.Shirakawa.\nNIFTY:GGB03257\nPC-VAN:NBG19972", appName, MB_OK);
               break;
          default:
               /* send WM_SYSCOMMAND DefWndProc() */
               return DefWindowProc(hWnd, Message, wParam, lParam);
          }
          break;
     case WM_DROPFILES:
          /* Get the number of pathnames that are being dropped on us */
          wFilesDropped = DragQueryFile((HDROP)wParam, -1, NULL, 0) - 1;
          /* Get the length of the the pathname */
          wSize = DragQueryFile((HDROP)wParam, wFilesDropped, NULL, 0) + 1;
          /* Allocate a block of memory large enough for the pathname */
          npszPathName = (NPSTR)LocalAlloc(LMEM_FIXED, wSize);
          if (npszPathName == NULL) { /* Insufficient memory */
               MessageBox(hWnd, "Insufficient memory", "WARNING",MB_OK|MB_ICONSTOP);
               break;
          }
          /* Copy the pathname into our local buffer */
          DragQueryFile((HDROP)wParam, wFilesDropped, npszPathName, wSize);
          cgcur(hWnd, (LPCSTR)npszPathName);
          LocalFree((HLOCAL)npszPathName);
          /* Free the memory block containing the pathnames */
          DragFinish((HDROP) wParam);
          break;

     case WM_DESTROY:
          /* hCurArrow = LoadCursor(NULL, IDC_ARROW);*/
          lpArrow = GlobalLock(hCurArrow);
          for (loop = 0; loop < size; loop++)
               *((unsigned char far*)lpArrow + loop) = tmp[loop];
          GlobalUnlock(hCurArrow);
          ShowCursor(FALSE);
          ShowCursor(TRUE);
          PostQuitMessage(0);
          break;
     case WM_QUERYOPEN:
          return FALSE;
     default:
          return DefWindowProc(hWnd, Message, wParam, lParam);
     }
     return 0L;
}
